import { DynamoDBDocument } from "@webiny/aws-sdk/client-dynamodb";
import { Client } from "@webiny/api-elasticsearch";
import { createTable } from "../definitions";
import { Context, IElasticsearchIndexingTaskValues, IManager } from "../types";
import { Entity } from "@webiny/db-dynamodb/toolbox";
import { ITaskResponse } from "@webiny/tasks/response/abstractions";
import { ITaskManagerStore } from "@webiny/tasks/runner/abstractions";
import { BatchReadItem, BatchWriteItem, BatchWriteResult } from "@webiny/db-dynamodb";
export interface ManagerParams {
    context: Context;
    documentClient?: DynamoDBDocument;
    elasticsearchClient?: Client;
    isCloseToTimeout: () => boolean;
    isAborted: () => boolean;
    response: ITaskResponse;
    store: ITaskManagerStore<IElasticsearchIndexingTaskValues>;
}
export declare class Manager implements IManager {
    readonly documentClient: DynamoDBDocument;
    readonly elasticsearch: Client;
    readonly context: Context;
    readonly table: ReturnType<typeof createTable>;
    readonly isCloseToTimeout: () => boolean;
    readonly isAborted: () => boolean;
    readonly response: ITaskResponse;
    readonly store: ITaskManagerStore<IElasticsearchIndexingTaskValues>;
    private readonly entities;
    constructor(params: ManagerParams);
    getEntity(name: string): Entity<any>;
    read<T>(items: BatchReadItem[]): Promise<T[]>;
    write(items: BatchWriteItem[]): Promise<BatchWriteResult>;
}
